#
#     26 Oct 96   for da adopted from charissa version
#    8 jan 98   modified for use with F2VB module

# May 2000 -  Silena 4418 DA
#    Now a common version for all uses of D2VB/F2VB moduleNameVME


set debug 0
set started 0

set frame SYS
set icontitle  "SysCntl"

set OS "Unknown"


if {![info exists DAProgram]} then {set DAProgram MIDASExecV1}

if {![info exists LynxOSDirectory]} then {set LynxOSDirectory /MIDAS/Data_Acq/bin/LynxOS_MCG/3.1.0/}
if {![info exists LinuxDirectory]}  then {set LinuxDirectory  /MIDAS/Data_Acq/bin/linux-mvme5500/}
if {![info exists Win32Directory]}  then {set Win32Directory  c:\\MIDAS\\Data_Acq\\bin\\Win32\\}
set DADirectory $LynxOSDirectory

if {![info exists UCL]} then {set UCL 0}

if {![info exists CAMACPresent]} then {set CAMACPresent 0}
if {![info exists VMEPresent]} then {set VMEPresent 0}
if {![info exists VXIPresent]} then {set VXIPresent 0}

if {![info exists CAMACEnable]} then {set CAMACEnable 0}
if {![info exists VMEEnable]} then {set VMEEnable 0}
if {![info exists VXIEnable]} then {set VXIEnable 0}

if {![info exists TSPresent]} then {set TSPresent 1}
if {![info exists EBPresent]} then {set EBPresent 0}

if {![info exists TSEnable]} then {set TSEnable 0}
set tapestate -1
set tapeassoc ""

set X2VBPresent 1

if {![info exists RDOUTEnable]} then {set RDOUTEnable 1}

if {![info exists histPresent]} then {set histPresent 1}
if {![info exists histEnable]} then {set histEnable 1}
if {![info exists HistMode]} then {set HistMode 1}

if {![info exists txEnable]} then {set txEnable 0}
if {![info exists ebtxEnable]} then {set ebtxEnable 0}

if {[info exists env(CamacServer)]} then {set resource $env(CamacServer)} else {set resource camac}
set CAMACserver $resource

if {[info exists env(VMEServer)]} then {set resource $env(VMEServer)} else {set resource vme}
set VMEserver $resource

if {[info exists env(VXIServer)]} then {set resource $env(VXIServer)} else {set resource VXI}
set VXIserver $resource

if {[info exists env(CamacController)]} then {set resource $env(CamacController)} else {set resource SCC}
set CAMACcontroller $resource

if {[info exists env(RDOUThdwre)] == 0} then {set hdwre F2VB} else {set hdwre $env(RDOUThdwre)}
set RDOUThdwre $hdwre

if {[info exists env(RDOUTserver)]} then {set resource $env(RDOUTserver)} else {set resource vme}
set RDOUTserver $resource

if {![info exists RDOUTserverList]} then {set RDOUTserverList $RDOUTserver}

#    Note - all use of the common register access procedures are for the ReadOut server
set RegisterServer $RDOUTserver

set SpectrumServerList {}
set SpectrumServer [first $SpectrumServerList]

if {![info exists CheckDAPeriod]} then {set CheckDAPeriod 15}

set vxistate 0
set vmestate 0
set camacstate 0
set tapestate 0
set readoutstate 0

set ScalerType LC2551

set S9418_Base 1
set V767_Base 16
set V1190_Base 24
set V1290_Base 24
set V785_Base 32
set V775_Base 32
set V792_Base 32
set V878_Base 32
set V879_Base 32

set Supported_Modules [list S9418 V785 V775 V792 V878 V879 V1190 V1290 V767 VME]

set RDOUTstate 0
set MaxTries 20

set Alive -1

#    default setup message is for FERA systems which use CAMAC

set SetupMessage "\n\
Are you sure you wish to SETUP the data acquisition system?\n\n\
SETUP will STOP data acquisition.\n\
Configure the CAMAC Control software and restore CAMAC parameter settings.\n\
It will also recreate all histograms selected.\n\
This may take several minutes.\n\n\
If you decide to continue please wait for the SETUP sequence to complete and DO NOT touch the system while it is in progress.
"

set TestBuffer ""

#    list of menu items and associated actions for the SETUPS menu button

set setuplist {                                             \
   {"Create GUI Registers"              "make-registers; make-executiveregisters"}    \
   {"Load Acquisition Options"          "Set_Options"}       \
}

#    list of menu items and associated actions for the ACTIONS menu button 

set actionlist {                                             \
   {"Configuration/Test/Debug Frame"    "make-test-frame"}   \
   {"Load Acquisition Options"          "Set_Options"}       \
   {"Save Acquisition Options"          "update_Options"}    \
   {"Enable DA System tracing"          "click-trace 1"}     \
   {"Disable DA System tracing"         "click-trace 0"}     \
   {"transferTxStatus"                  "click-special 1"}   \
   {"transferTxReset"                   "click-special 2"}   \
   {"transferInit"                      "click-special 3"}   \
   {"Start test task"                   "click-testmode 0"}  \
   {"End test task"                     "click-testmode 1"}  \
   {"Show DA software ID"               "click-ID"}          \
   {"Release all spectra"               "unmap_spectra"}     \
   {"Map all spectra"                   "map_spectra"}       \
   {"toggle readout pause state"        "click-special 7"}   \
}

#    list of registers required by the GUI

set registerlist { 
   {NetVar.EXEC.Action              generic  "-n EXEC_Action -t int"} \
   {NetVar.EXEC.Parameter           generic  "-n EXEC_Parameter -t string"} \
   {NetVar.EXEC.Response            generic  "-n EXEC_Response -t block -a yes -i 0 -l 444 -f x"}  \
   {NetVar.EXEC.ID                  generic  "-n EXEC_ID -t string"} \
   {NetVar.TS_Server                generic  "-n TS_Server -t string"} \
   {NetVar.TS_Port                  generic  "-n TS_Port -t int"} \
   {NetVar.Xfer_Option              generic  "-n Xfer_Option -t int"} \
   {NetVar.Format_Option            generic  "-n Format_Option -t int"} \
   {NetVar.EB_Server                generic  "-n EB_Server -t string"} \
   {NetVar.EB_Port                  generic  "-n EB_Port -t int"} \
   {NetVar.EBXfer_Option            generic  "-n EBXfer_Option -t int"} \
   {NetVar.RawDataStorage           generic  "-n RawDataStorage -t string"} \
}

lappend registerlist [list NetVar.EXEC.PID    generic  "-n PID_EXEC -t int"]

if {$RDOUThdwre != "1394"} {
   lappend registerlist [list SigTask.EXEC.Usr1   sigTask  "-t EXEC -s USR1"]
   lappend registerlist [list SigTask.EXEC.Usr2   sigTask  "-t EXEC -s USR2"]
} else {
   lappend registerlist [list SigTask.EXEC.Usr1   sigTask  "-t EXEC -s USR1 -m 1"]
   lappend registerlist [list SigTask.EXEC.Usr2   sigTask  "-t EXEC -s USR2 -m 1"]
}

set executiveregisters {
    {SigTask.Executive.Usr1      sigTask  "-t Executive -s USR1"}  \
    {NetVar.Executive.Action     generic  "-n Executive_Action -t int"}  \
    {NetVar.Executive.Parameter  generic  "-n Executive_Parameter -t string"} \
    {NetVar.Executive.ID         generic  "-n Executive_ID -t string"}  \
    {NetVar.Executive.PID        generic  "-n PID_Executive -t int"}  \
    {NetVar.Executive.Trace      generic  "-n Executive_Trace -t int"}  \
    {NetVar.Executive.State      generic  "-n Executive_State -t int"}  \
}

if {$RDOUThdwre != "1394"} {
   lappend executiveregisters [list SigTask.Executive.Usr1   sigTask  "-t Executive -s USR1"]
}

if {$VERSION == "MIDAS" || $VERSION == "TIARA" || $VERSION == "F2VB"} {
   lappend registerlist [list NetVar.TDC.Mode             generic  "-n TDC_Mode -t int"]
   lappend registerlist [list NetVar.TDC.Option           generic  "-n TDC_Option -t int"]
   lappend registerlist [list NetVar.TDC.Reference        generic  "-n TDC_Reference -t int"]
   lappend registerlist [list NetVar.ReadOutOption        generic  "-n ReadOutOption -t int"]
}

lappend registerlist [list NetVar.DACQ.CAlive              generic  "-n DACQ_Alive -t int"]
lappend registerlist [list NetVar.DACQ.Ctxenable           generic  "-n DACQ_TxEnable -t int"]
lappend registerlist [list NetVar.DACQ.Cebtxenable         generic  "-n DACQ_EBTxEnable -t int"]
lappend registerlist [list NetVar.DACQ.Crdoutenable        generic  "-n DACQ_RdOutEnable -t int"]
lappend registerlist [list NetVar.DACQ.Chistenable         generic  "-n DACQ_HistEnable -t int"]
lappend registerlist [list NetVar.DACQ.Chistmode           generic  "-n DACQ_HistMode -t int"]
lappend registerlist [list NetVar.DACQ.Cspectramapped      generic  "-n DACQ_SpectraMapped -t int"]
lappend registerlist [list NetVar.DACQ.Ctrace              generic  "-n DACQ_Trace -t int"]
lappend registerlist [list NetVar.DACQ.Sstate              generic  "-n DACQ_State -t int"]
lappend registerlist [list NetVar.DACQ.TestMode            generic  "-n DACQ_TestMode -t int"]
lappend registerlist [list NetVar.DACQ.DebugMode1          generic  "-n DACQ_DebugMode1 -t int"]
lappend registerlist [list NetVar.DACQ.DebugMode2          generic  "-n DACQ_DebugMode2 -t int"]
lappend registerlist [list NetVar.DACQ.DebugMode3          generic  "-n DACQ_DebugMode3 -t int"]
lappend registerlist [list NetVar.DACQ.DelayTicks          generic  "-n DACQ_DelayTicks -t int"]
lappend registerlist [list NetVar.DACQ.PollTicks           generic  "-n DACQ_PollTicks -t int"]
lappend registerlist [list NetVar.DACQ.StatsTime           generic  "-n DACQ_StatsTime -t int"]
lappend registerlist [list NetVar.DACQ.Stats1               generic  "-n DACQ_Stats -t block -a yes -i 0 -l 400 -f d"]
lappend registerlist [list NetVar.DACQ.Stats2               generic  "-n DACQ_Stats -t block -a yes -i 400 -l 400 -f d"]
lappend registerlist [list NetVar.DACQ.Rates1               generic  "-n DACQ_Rates -t block -a yes -i 0 -l 444 -f d"]
lappend registerlist [list NetVar.DACQ.Rates2               generic  "-n DACQ_Rates -t block -a yes -i 400 -l 400 -f d"]

lappend registerlist [list NetVar.UseGroup     generic  "-n DACQ_UseGroup -t int"]


if {$RDOUThdwre == "D2VB"} {
   lappend registerlist [list NetVar.NumVXICrates     generic  "-n NumVXICrates -t int"]
   lappend registerlist [list NetVar.CrateMap         generic  "-n CrateMap -t int"]
   lappend registerlist [list NetVar.TitrisPresent    generic  "-n TitrisPresent -t int"]
   lappend registerlist [list NetVar.CentrumPresent   generic  "-nCentrumPresent -tint"]
   lappend registerlist [list NetVar.TimeFilter       generic  "-n TimeFilter -t int"]
}

if {$RDOUThdwre == "D2VB" || $RDOUThdwre == "F2VB"} {
   lappend actionlist [list "Start RAW Data Storage" "StartRawDataStorage"]
   lappend actionlist [list "Stop RAW Data Storage"  "click-special 9"]
}

lappend actionlist [list "Print Hardware Configuration"  "PrintConfig"]

proc StartRawDataStorage {} {
    write-register NetVar.RawDataStorage "/rootfs/tmp/X2VBRawData"
    click-special 8
}

if {$VERSION == "GREAT"} {
   lappend registerlist [list NetVar.DACQ.OutputAll    generic  "-n Merge_OutputAll -t int"]

   lappend actionlist [list "All Data goes to tape"  "write-register NetVar.DACQ.OutputAll 1"]
   lappend actionlist [list "Good Data only to tape" "write-register NetVar.DACQ.OutputAll 0"]
}


proc Set_Options {} {
    global Options Supported_Modules

    load_Options

    Set_Common_Options

    foreach module $Supported_Modules {
        if {![info exists Options(Include.$module)]} {set Options(Include.$module) 1}
        if {![info exists Options(Histogram.$module)]} {set Options(Histogram.$module) 1}
        if {$Options(Include.$module) == 1} then {
            loadsource sys.[set module]
            Set_[set module]_Options
        }
    }

    update_Options
}

proc Set_Common_Options {} {
    global Options

    load_Options

   if {![info exists Options(Stat.channels)]} {set Options(Stat.channels) 4096}
   if {![info exists Options(Rate.channels)]} {set Options(Rate.channels) 4096}

    update_Options

}

proc Dump_Raw_VME_Data {} {
    global Options

   set info ""

   if {$Options(Include.S9418) == 1} then {append info [Dump_Raw_VME_Data_S9418]}

   set CAEN_ModuleNum 0
   foreach m [list V785 V775 V792 V878 V879 V1190 V1290 V767] {

       set maxmodule [inform vmecontrol inquire [string tolower $m]count]
       if {[string length $maxmodule] > 2} {set maxmodule 0}

       incr CAEN_ModuleNum $maxmodule       
   }

   for {set CAEN_ModuleIndex 1} {$CAEN_ModuleIndex <= $CAEN_ModuleNum} {incr CAEN_ModuleIndex} {

      execute-command 19 "Getting Raw Data for CAEN module $CAEN_ModuleIndex" "1 $CAEN_ModuleIndex" 2
      set data [read-register NetVar.EXEC.Response]

      set CAEN_ModuleType [expr 0x[first $data]]

      append info "CAEN module $CAEN_ModuleIndex is type V$CAEN_ModuleType\n"
      catch {append info "[Dump_Raw_VME_Data_V$CAEN_ModuleType [lreplace $data 0 0]]\n"}

   }

   if {$Options(Include.VME) == 1} then {append info [Dump_Raw_VME_Data_VME]}

#   midas-information "$info"
    set frame [self frame-name].info

    :frame $frame :label  "Information from [self frame-title]" :toplevel T
         wm protocol $frame WM_DELETE_WINDOW "destroy $frame"

    :galley G :deaf T :strings $info :font fixed :rows 70 :cols 85
    :show T
}

proc Dump_Raw_VXI_Data {} {

   set info "VXI\n"

   execute-command 19 "Getting Raw Data for VXI" 6 2
   append data [read-register NetVar.EXEC.Response]

     foreach word $data {
         set word 0x$word
         if {$word == 0xaa5555aa} then {
             append info "\n$word - end of dump\n"
             break
         }
         if {$word == 0x55aaaa55} then {
             append info "\n$word - end of event\n"
             continue
         }
         append info "$word "
     }

   midas-information "$info"
}

proc midas-information {text} {

    set frame [self frame-name].info

    :frame $frame :label  "Information from [self frame-title]" :toplevel T
         wm protocol $frame WM_DELETE_WINDOW "destroy $frame"

    :galley G :deaf T :strings $text :font fixed
    :show T
}

proc write-register {r v} {
    global RDOUTserverList

    foreach server $RDOUTserverList {
        EG "register :name '/$server/$r' :value '$v'"
    }
}

proc read-register {r} {
    global RDOUTserverList

    foreach server $RDOUTserverList {
        set vl [EG "register :name '/$server/$r' ?value"]
    }
    return $vl
}

proc execute-command {args} {
    global RDOUTserver RDOUTserverList

#    first      action
#    second     message
#    third      parameter
#    fourth     signal number
#    fifth      task name 

    if {[llength $args] > 4} then {set TASK [fifth $args]} else {set TASK EXEC}

    foreach server $RDOUTserverList {
        set pid [EG "register :name '/$server/NetVar.$TASK.PID' ?value"]
        if {[llength $args] > 2} {EG "register :name '/$server/NetVar.$TASK.Parameter' :value '[third $args]'"}
        EG "register :name '/$server/NetVar.$TASK.Action' :value '[first $args]'"
        if {[llength $args] > 3} {
            EG "register :name '/$server/SigTask.$TASK.Usr[fourth $args]' :object '-t $pid'"
            EG "register :name '/$server/SigTask.$TASK.Usr[fourth $args]' :value '0'"
        } else {
            EG "register :name '/$server/SigTask.$TASK.Usr1' :object '-t $pid'"
            EG "register :name '/$server/SigTask.$TASK.Usr1' :value '0'"
        }
        after 25
        set RDOUTserver $server
        if {[llength $args] > 1} {wait_for_completion $TASK "[second $args]"} else {wait_for_completion $TASK ""}
    }
}

proc wait_for_completion {args} {
    global RDOUTserver MaxTries EGreport

    set tries 1
    set TASK EXEC

    while {$tries < $MaxTries} {

        if {[llength $args] == 0} then {
            if {$EGreport != -1} then {set-footer "$RDOUTserver: Waiting for action to complete ($tries)"}
        } else {
            if {[llength $args] > 1} then {
                set TASK [first $args]
                if {$EGreport != -1} then {set-footer "$RDOUTserver: [second $args] ($tries)"}
            } else {
                if {$EGreport != -1} then {set-footer "$RDOUTserver: [first $args] ($tries)"}
            }
        }

        set z [catch {EG "register :name '/$RDOUTserver/NetVar.$TASK.Action' ?value"} m ]

        if {$z != 0} then {
            midas-warning "$RDOUTserver: Unable to confirm state of action\n$m"
            clear-footer
            return 1
        }

        if {$m == 0} then {
            if {$EGreport != -1} clear-footer
            return 0
        }
        incr tries
        after 500
    }

    midas-warning "$RDOUTserver: Action has not completed\nGiving up waiting"
    clear-footer
    return 1
}

proc executive-command {args} {

    if {[llength $args] == 1} then { 
        execute-command 1 "executive command" "[first $args]" 1 Executive
    } else {
        execute-command 1 "[first $args]" "[second $args]" 1 Executive
    }
    wait_for_completion Executive
}

proc make-registers {} {
    global registerlist RegisterServer RDOUTserverList
    global EGreport

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

    set EGreport_SAVE $EGreport
    set EGreport -1
    set-footer "defining registers"

    foreach server $RDOUTserverList {
        set RegisterServer $server
        foreach item $registerlist {
            define-register [second $item] [first $item] "[third $item]"
        }
    }

    clear-footer
    set EGreport $EGreport_SAVE
}

proc make-executiveregisters {} {
    global executiveregisters RegisterServer RDOUTserverList
    global EGreport

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

    set EGreport_SAVE $EGreport
    set EGreport -1
    set-footer "defining registers"

    foreach server $RDOUTserverList {
        set RegisterServer $server
        foreach item $executiveregisters {
            define-register [second $item] [first $item] "[third $item]"
        }
    }

    clear-footer
    set EGreport $EGreport_SAVE
}

proc starttask {task} {
#    Check if it is necessary to pre-start server interface task

    set started [inform $task inquire started]
    if {$started == 0} then {
       send $task start
       send $task close-frame
       after 2000
    }
}

proc click-tapes {action} {
   global TSEnable

   if {$TSEnable == 0} then {redisplay-tapes; return}

   starttask tape

#    set tape server state

   send tape click-egstate $action
   redisplay-tapes
   update_button_states
}

proc redisplay-tapes {} {
   global TSEnable tapestate tapeassoc

   if {$TSEnable == 0} then {:modify TAPE :value -1; return}

   set-busy
   starttask tape
  
#    find tape server state

   catch {set tapestate [send tape read-egstate]}
   :modify TAPE :value $tapestate

#    find run number

   catch {set run [fifth [send tape inquire-ganil-status]]}
   :modify RUN :value $run

#    find data stream association

   catch {set tapeassoc [send tape find-assoc-strings 1]}
   :modify STREAM :value "$tapeassoc"

   catch {send tape update-information}

   if {$tapestate == 0} then {
       set rate 0
   } else {
       catch {set rate [first [send tape inquire taperates]]}
   }
   :modify RATE :value $rate

   catch {:modify PERCENT :value [string range [inform tape inquire tapepercent] 0 3]}

   clear-busy
}
  
proc click-da {v} {
        global debug env VERSION RDOUTstate  RDOUTEnable TSEnable CAMACEnable VMEEnable VXIEnable
        if {$debug} then {puts stderr "setting MIDAS DA to state $v"}

    Custom_PreCheck $v

#    First check that the servers have been configured - that is registers for the installed hardware have been created
#    This is performed when the server is installed for VXI

    if {$VMEEnable != 0 && [inform vmecontrol HasBeenConfigured] == 0} then {
         midas-warning "The VME server has not been configured\nIt may recently have been restarted\nUse SETUP first"
         return -1
    }

    if {$CAMACEnable != 0 && [inform camaccontrol HasBeenConfigured] == 0} then {
         midas-warning "The CAMAC server has not been configured\nIt may recently have been restarted\nUse SETUP first"
         return -1
    }

#    Now if the action is GO ensure that a parameter restore has been performed

    if {$v == 1} {

    if {$CAMACEnable != 0 && [inform camacsaverestore HasBeenRestored] == 0} then {
         set r [midas-confirmation "You have not performed a parameter restore for the CAMAC server\nIt may recently have been restarted\n\
                          Do you wish to continue or to abort so that you can SETUP first"]
         if {$r == 0} then {return -1}
    }

    if {$VMEEnable != 0 && [inform vmesaverestore HasBeenRestored] == 0} then {
         set r [midas-confirmation "You have not performed a parameter restore for the VME server\nIt may recently have been restarted\n\
                          Do you wish to continue or to abort so that you can SETUP first"]
         if {$r == 0} then {return -1}
    }

    if {$VXIEnable != 0 && [inform vxicontrol VXI-ResetState] == 0} then {
         set r [midas-confirmation "The VXI control software has NOT performed a software reset\n\
               for one or more VXI servers\nIt may recently have been restarted\n\
               Your VXI hardware may not operate correctly unless this is done.\n\
               Do you wish to continue or to abort so that you can SETUP first"]
         if {$r == 0} then {return -1}
    }

    if {$VXIEnable != 0 && [inform vxicontrol VXI-RestoreState] == 0} then {
         set r [midas-confirmation "You have not performed a parameter restore for one or more VXI servers\nIt may recently have been restarted\n\
                          Do you wish to continue or to abort so that you can SETUP first"]
         if {$r == 0} then {return -1}
    }

    }

     Custom_PostCheck $v

     if {$RDOUTEnable != 0} then {set RDOUTstate $v}

    set z [catch {
        if {$v==0} then {
            set-footer "STOPping $VERSION Data Acquisition [date]"
                Custom_PreStop
                Stop_Electronics
                click-vxi 0
                click-camac 0
                click-vme 0
                click-rdout 0
                click-tapes 0
                Custom_PostStop
            set-footer "$VERSION Data Acquisition STOPped [date]"
            insert-log "sys: [date] Data Acquisition STOPPED"
         }
         if {$v==1} then {
            set-footer "GOing $VERSION Data Acquisition [date]"
                Custom_PreGo
                if {$RDOUTEnable != 0} then {
                    set state [read-register NetVar.DACQ.Sstate]
                    if {$state == 2} then {
                        midas-warning "Data Acquisition is already running - Use STOP first"
                        clear-footer
                        return -1
                    }
                }
                if {$TSEnable != 0} then {
                    if {[send tape read-storagestate] != 0} then {
                         set r [midas-confirmation "Tape Server is in No Storage state\n\
                                Do you wish to continue or to abort so that you can change this"]
                         if {$r == 0} then {return -1}
                    }
                    click-tapes 1
                    if {[send tape read-egstate] != 1} then {
                         set r [midas-confirmation "Tape Server not in Going state\n\
                                Do you wish to continue or to abort so that you can correct the problem"]
                         if {$r == 0} then {return -1}
                    }
                }
                Reset_Electronics
                if {$RDOUTEnable != 0} then {
                    click-rdout 3
                    click-rdout 1
                    if {[read-register NetVar.DACQ.Sstate] != 2} then {
                         midas-warning "Data Acquisition Program not in Going state\n\GO aborted"
                         return -1
                    }
                }
                click-vme 1
                click-camac 1
                click-vxi 1
                Go_Electronics
                Custom_PostGo
            set-footer "$VERSION Data Acquisition GOing [date]"
            insert-log "sys: [date] Data Acquisition GOING"
         }
     } m ]

   set footertext $env(FooterText)
   click-redisplay
   set-footer $footertext

    return [da_state]
}

if {$UCL == 1} then {proc do-runtime {w v} {}}

#    the following three procedures are available for applications to perform the critical DA hardware control
proc Stop_Electronics {} {}
proc Go_Electronics {} {}
proc Reset_Electronics {} {}

#    the following ten procedures are available for applications to perform specific actions during the general control sequences 
proc Custom_PreCheck {opt} {}    ;# opt = 0 STOP,  opt = 1 GO,  opt = 2 SETUP
proc Custom_PostCheck {opt} {}
proc Custom_PreStop {} {}
proc Custom_PostStop {} {}
proc Custom_PreGo {} {}
proc Custom_PostGo {} {}
proc Custom_PreSetup {opt} {}  ;#  opt = 0 setup where needed,  opt = 1  setup everything,  opt = 2  prompt
proc Custom_SetupA {opt} {}    ;#  opt = 0 setup where needed,  opt = 1  setup everything,  opt = 2  prompt
proc Custom_SetupB {opt} {}    ;#  opt = 0 setup where needed,  opt = 1  setup everything,  opt = 2  prompt
proc Custom_SetupC {opt} {}    ;#  opt = 0 setup where needed,  opt = 1  setup everything,  opt = 2  prompt
proc Custom_SetupD {opt} {}    ;#  opt = 0 setup where needed,  opt = 1  setup everything,  opt = 2  prompt
proc Custom_PostSetup {opt} {}
proc Custom_Redisplay {} {}
proc Custom_Start {} {}

proc click-setup {arg} {
    global CAMACEnable CAMACserver CAMACcontroller VMEEnable VXIEnable VXIserver  RDOUTEnable
    global histPresent txEnable ebtxEnable histEnable
    global SetupMessage

    make-registers
    make-executiveregisters

    Set_Options

    click-histenable $histEnable

    click-txenable $txEnable
    click-ebtxenable $ebtxEnable


    if {$arg == 0} then {

#    allow the user to chicken out!

        set z [catch {midas_dialog [self frame-name].confirmDialog "Confirmation Request for Data Acquisition SETUP" \
           "$SetupMessage" "" 1 "Cancel" "Setup where needed" "Setup everything" "Prompt me"} m]
        if {$z != 0} then {
           puts stderr "midas-warning: [self frame-name].confirmDialog: $m"
           destroy [self frame-name].confirmDialog
           return 0
        }

        if {$m == 0} then {return}
        set opt [expr $m - 1]

    } else {
        set opt 0
    }

#    insert-log "SetUp with option $opt"

    Custom_PreCheck 2

   if {$CAMACEnable != 0} then {

        do_inhibit_camac

    if {[inform camaccontrol Configuration] == ""}    then {inform camacsaverestore click-CSRrestore-current}
    if {[inform camaccontrol Configuration] == ""} then {
        midas-warning "CAMAC server is not correctly configured\nPlease correct this and retry SETUP"
        return
    }

    if {[inform camaccontrol HasBeenConfigured] == 0} then {inform camaccontrol load-configuration}
    if {[inform camaccontrol HasBeenConfigured] == 0} then {
        midas-warning "CAMAC server is not correctly configured\nPlease correct this and retry SETUP"
        return
    }
  }

  if {$VMEEnable != 0} then {

#    load VME configuration and create registers
    if {[inform vmecontrol Configuration] == ""}    then {inform vmesaverestore click-CSRrestore-current}
    if {[inform vmecontrol Configuration] == ""} then {
        midas-warning "VME server is not correctly configured\nPlease correct this and retry SETUP"
        return
    }

    if {[inform vmecontrol HasBeenConfigured] == 0} then {inform vmecontrol Configure}
    if {[inform vmecontrol HasBeenConfigured] == 0} then {
        midas-warning "VME server is not correctly configured\nPlease correct this and retry SETUP"
        return
    }
  }

  if {$VXIEnable != 0} then {
     if {$opt != 2} then {
        if {[inform vxicontrol inquire VXIconfigured] == 0} then {inform vxicontrol "configure-all  1"}
     } else {
        if {[inform vxicontrol inquire VXIconfigured] != 0} then {
            set r [midas-confirmation "The VXI control software has already been configured and so this does not need to be repeated.\n\
               However if you have recently made changes to the VXI hardware installed the VXI control software should probe the hardware \
               to update its configuration information." \
               "Probe for VXI hardware changes?"  "Skip to next step (recommended)"]
            if {$r == 0} then {inform vxicontrol "configure-all  1"}
        } else {
            set r [midas-confirmation "The VXI control software has NOT been configured and so is uncertain about your VXI hardware.\n\
               The VXI control software should probe the hardware to obtain the configuration information." \
               "Probe for VXI hardware changes? (recommended)"  "Skip to next step"]
            if {$r == 0} then {inform vxicontrol "configure-all  1"}
        }
     }
  }

#    check DA program installed
     if {[checkinstallation] != 0} then {return}

    Custom_PostCheck 2

#    stopping DA
    click-da 0

     Custom_PreSetup $opt

#    setup readout software
    click-rdout 2

   if {$CAMACEnable != 0} then {

#    reset camac hardware
    click-camac 2

#   restore CAMAC parameters
     if {[inform camacsaverestore HasBeenRestored] == 0 || $opt != 0} then {inform camacsaverestore click-SSRrestore-current}
     if {[inform camacsaverestore HasBeenRestored] == 0} then {
        midas-warning "CAMAC parameter restore has not been successful\nYou may need to correct this and retry SETUP"
     }
   }

     Custom_SetupA $opt

   set Copt $opt
   if {$VMEEnable != 0} then {

#    reset VME hardware
    click-vme 2

#   setup VME hardware and restore VME parameters
     if {[inform vmesaverestore HasBeenRestored] == 0 || $opt != 0} then {
         click-vme 3
         inform vmesaverestore click-SSRrestore-current
         set Copt 1
     }
     if {[inform vmesaverestore HasBeenRestored] == 0} then {
        midas-warning "VME parameter restore has not been successful\nYou may need to correct this and retry SETUP"
     }
   }

     Custom_SetupB $Copt

   if {$VXIEnable != 0} then {

#   reset VXI

     if {$opt != 2} then {
        if {[inform vxicontrol VXI-ResetState] == 0 || $opt != 0} then {inform vxicontrol DAQ-reset}
     } else {
        if {[inform vxicontrol VXI-ResetState] != 0} then {
            set r [midas-confirmation "The VXI control software has already performed a software reset and so this does not need to be repeated.\n\
               You may repeat the software reset if you wish but this may cause VXI module setup information to be lost." \
               "Perform software reset?"  "Skip to next step (recommended)"]
            if {$r == 0} then {click-vxi 3}
        } else {
            set r [midas-confirmation "The VXI control software has NOT performed a software reset.\n\
               Your VXI hardware may not operate correctly unless this is done." \
               "Perform software reset? (recommended)"  "Skip to next step"]
            if {$r == 0} then {click-vxi 3}
        }
     }

     if {[inform vxicontrol VXI-ResetState] == 0} then {
         midas-warning "VXI software reset has not been successful\nYou may need to correct this and retry SETUP"
     }

     Custom_SetupC $opt

#    setup VXI hardware

     if {$opt != 2} then {
        if {[inform vxicontrol VXI-SetupState] == 0 || $opt == 1} then {click-vxi 4} else {click-vxi 4 1}
     } else {
        if {[inform vxicontrol VXI-SetupState] != 0} then {
            set r [midas-confirmation "The VXI control software has already performed a software setup and so this does not need to be repeated.\n\
               You may repeat the software setup if you wish but this may cause VXI module setup information to be lost." \
               "Perform software setup?"  "Skip to next step (recommended)"]
            if {$r == 0} then {click-vxi 4}
        } else {
            set r [midas-confirmation "The VXI control software has NOT performed a software setup.\n\
               Your VXI hardware may not operate correctly unless this is done." \
               "Perform software setup? (recommended)"  "Skip to next step"]
            if {$r == 0} then {click-vxi 4}
        }
     }

     if {[inform vxicontrol VXI-SetupState] == 0} then {
         midas-warning "VXI software setup has not been successful\nYou may need to correct this and retry SETUP"
     }

     Custom_SetupD $opt

#   restore VXI parameters

     set-busy

     set r 1
     if {$opt != 2} then {
        if {[inform vxicontrol VXI-RestoreState] == 0 || $opt == 1} then {
            set r 0
            if {$opt == 0} then {
                inform vxirestore "click-restore-current 1"
            } else {
                inform vxirestore "click-restore-current 0"
            }
        }
     } else {
        if {[inform vxicontrol VXI-RestoreState] != 0} then {
            set r [midas-confirmation "The VXI control software has already performed a parameter restore and so this does not need to be repeated.\n\
               You may repeat the parameter restore if you wish or because you suspect that the parameters may have become corrupted.\n\
               If you choose to perform a restore parameters will be taken from the current save for each VXI crate."\
               "Perform parameter restore?"  "Skip to next step (recommended)"]
            if {$r == 0} then {inform vxirestore "click-restore-current 0"}
        } else {
            set r [midas-confirmation "The VXI control software has NOT performed a parameter restore.\n\
               Your VXI hardware may not operate correctly unless this is done.\n\
               If you choose to perform a restore parameters will be taken from the current save for each VXI crate."\
               "Perform parameter restore? (recommended)"  "Skip to next step"]
            if {$r == 0} then {inform vxirestore "click-restore-current 0"}
        }
     }
     if {$r == 0} then {inform  vxirestore destroy  .vxirestore.info}

     if {[lsearch [inform bf inquire tasklist] "vre #"] >= 0} then {
#    reload the VRE firmware which may have been changed
         if {$r == 0} then {inform vre vre-reloadDSP $VXIserver}
     }
    
     if {[inform vxicontrol VXI-RestoreState] == 0} then {
        midas-warning "VXI parameter restore has not been successful\nYou may need to correct this and retry SETUP"
     }

     clear-busy
   }

     Custom_PostSetup $opt

    if {$histPresent != 0} then {setup_histograms}

#    update display
    click-redisplay

    if {$opt == 2} then {
        midas-report "MIDAS Data Acquisition System SETUP and ready to GO at [date]"
    }

    insert-log "MIDAS Data Acquisition System SETUP and ready to GO at [date]"
    set-footer "MIDAS DA System SETUP and ready to GO at [date]" 
}

proc setup_histograms {} {
    global RDOUThdwre VXIPresent

#    create and enable histograms

     set-footer "Setting up histogramming"
     set-busy
     unmap_spectra
     if {$VXIPresent == 0} then {delete_spectra}
#     if {$RDOUThdwre != "VME"} then {ClearConfig}   -  != VME means D2VB (not used)  and   F2VB
     create_spectra
     if {$VXIPresent == 1} then {map_spectra}
     clear-busy
     clear-footer
}

proc click-vxipause {opt} {
        switch $opt {
          1  {inform vxicontrol "Stop-VXI VXI"}
          0  {inform vxicontrol "Go-VXI  VXI"}
        }
    redisplay-vxi
    update_button_states
}

proc map_spectra {} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   execute-command 5 "Mapping spectra"
}

proc unmap_spectra {} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   map_needed

   execute-command 8 "Unmapping spectra"
}

proc map_spectrum {s} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   execute-command 10 "Mapping spectrum [first $s]" "$s 0 0 0 0"
}

proc unmap_spectrum {s} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   execute-command 11 "Unmapping spectrum $s" $s
}

proc map_needed {} {
   global RDOUTEnable VXIPresent

   if {$RDOUTEnable == 0} then {return}
   if {$VXIPresent == 0} then {return}

   write-register NetVar.DACQ.Cspectramapped 0
}

proc map_not_needed {} {
   global RDOUTEnable 

   if {$RDOUTEnable == 0} then {return}

   write-register NetVar.DACQ.Cspectramapped 1
}

proc map_?_needed {} {
   global RDOUTEnable 

   if {$RDOUTEnable == 0} then {return 1}

   return [read-register NetVar.DACQ.Cspectramapped]
}

proc ClearConfig {} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   execute-command 12 "Clear Configuration"
}


#    the following procedure is a default which is useful for VME data sources
#    the procedure may be defined by application specific code
proc DefineConfig {s} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

#    format of module configuration record is  type  module_number  VME_address
#    where type = 9418 (S9418)
#                 0 (Acquisition control module)
#                 767 (CAEN V767 TDC module)
#                 1190 (CAEN V1190 TDC module)
#                 1290 (CAEN V1290 TDC module)
#                 785 (CAEN V785 ADC module)
#    also modules similar to the 785 - 775, 792, 878 and 879

   execute-command 13 "Define Configuration" "$s" 
}

#    this is a dummy procedure
proc define_VME_addresses {} {}

proc define_sac_config {} {
   global VMEserver

      set maxmodule [inform vmecontrol inquire saccount]
      if {[string length $maxmodule] > 2} {set maxmodule 0}
      
      if {$maxmodule != 0} {

          set z [catch {eg "(register :name '/$VMEserver/sac#1.STR'  ?object)" } m]
          if {$z!=0} then {
              display-eg-error-report self $m "Attempting to locate register sac#1.STR"
              clear-footer
              error $m
          }
          DefineConfig "0 0 [string range [first $m] 2 end]"
      }
}

proc PrintConfig {} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   execute-command 4 "Print Configuration" 0 2
}

proc spectra-names {} {
    global SpectrumServer

    set z [catch {eg "(spectrum :path '/$SpectrumServer' ?names)"} m]
    if {$z!=0} then {
       midas-warning "Unable to obtain spectrum names from $SpectrumServer: -  $m"
       clear-footer
       set m ""
    }
    return $m
}

#    procedure to be supplied by application specific code
proc create_spectra {} {}

proc delete_spectra {} {
   global SpectrumServer SpectrumServerList

   set-footer "Deleting spectra"

   foreach server $SpectrumServerList {
       set SpectrumServer $server

       set spectra [spectra-names]
       foreach item $spectra {
           set name [second $item]
           set z [catch {eg "(spectrum :path '/$SpectrumServer'  :name '$name' !delete)" } m]
       }
   }
}


if {![info exists XlatePres]}       {set XlatePres 0}

proc SpectrumName {n} {Give_Xlate $n}

proc Make_Xlate {n} {
   global env Xlate XlateR XlatePres

   if {[info exists Xlate]}  {unset Xlate}
   if {[info exists XlateR]} {unset XlateR}
   set XlatePres 0

     set z [catch {set directory [file join $env(EXPERIMENTBASE) Histconfigs]} m]
     if {$z != 0} then {
        midas-warning "$m\nYou should probably Join an experiment!"
        close-frame
        return
     }

     if {![file exists $directory]} then {
        set z [catch {:file mkdir $directory} m]
        if {$z!=0} then {midas-warning "Cannot create directory $directory\n $m"}
     }

   #  read name translation file

   set file [file join $directory [set n]_names]
   set z [catch {open $file r} f]
   if {$z != 0} then {
       set-footer "Histogram name translation file does not exist"
       set Names {}

       set z [catch {open $file w} f]
       if {$z != 0} then {midas-warning "Unable to write file $file\n$f"; return}
       close $f

   } else {
       clear-footer ""
       set Names [split [read $f] \n]
       close $f
   }
   
   foreach item $Names {
       if {$item == ""} {continue}
       if {[third $item] == 0} {continue}
       if {[string range [first $item] 0 0] == "#"} continue
       set Xlate([first $item])  [second $item]
       set XlateR([second $item])  [first $item]
       set XlatePres 1
   }
}

proc Give_Xlate {n} {Do_Xlate $n}
proc Give_XlateR {n} {Do_XlateR $n}

proc Do_Xlate {n} {
   global XlatePres Xlate

   if {$XlatePres == 0} {return $n}
   if {[info exists Xlate($n)]} {return $Xlate($n)} else {return $n}
}

proc Do_XlateR {n} {
   global XlatePres XlateR

   if {$XlatePres == 0} {return $n}
   if {[info exists XlateR($n)]} {return $XlateR($n)} else {return $n}
}

proc Show_Xlate {} {
    global XlatePres Xlate XlateR
    global _information_font

    if {$XlatePres == 0} {return}

    set contents ""

    set l1 [lsort -dictionary [array names Xlate]]
    set l2 [lsort -dictionary [array names XlateR]]

    set i 0
    foreach name $l1 {
        set n1 [lindex $l1 $i]
        append contents [format "%24s %24s\n" $n1 $Xlate($n1)]
        incr i
    }

    append contents "\n\n"

    set i 0
    foreach name $l2 {
        set n2 [lindex $l2 $i]
        append contents [format "%24s %24s\n" $n2 $XlateR($n2)]
        incr i
    }
    
    set _information_font fixed
    midas-information "$contents"
}

proc Edit_Xlate {text}  {
    global env __editxlatedone


  :frame "[self frame-name].textedit" :label "[self frame-title]" :show-footer T  :resize F :toplevel T \
      :icon-image "@$env(ICONHOME)/default" \
      :icon-name "[self icon-title]"

    set __editxlatedone 0
  
    :panel TEXTEDITPANEL :layout T :padx 10 :pady 10
      :layout H; :row-gap 5; :col-gap 20

    :galley TEXTEDIT :rows 50 :cols 100 :font fixed
     :next-row T

    :button TEXTEDITDONE :label "Save file and finish"     :command Edit_Xlate_done
    :button TEXTEDITQUIT :label "Quit without saving file" :command Edit_Xlate_quit
    :show T

    :modify TEXTEDIT :strings "$text" 

   vwait __editxlatedone

   if {$__editxlatedone == 1}  {
       set text "[[:path TEXTEDIT].text get 1.0 end]"
   } else {
       set text ""
   }

   destroy "[self frame-name].textedit"

   return $text
}

proc Edit_Xlate_done {} {global __editxlatedone; set __editxlatedone 1}
proc Edit_Xlate_quit {} {global __editxlatedone; set __editxlatedone 2}


proc edit_xlate {}  {
   global XlatePres Xlate
   global env SpectrumServer

   if {$XlatePres == 0} then {Make_Xlate $SpectrumServer}
#   if {$XlatePres == 0} then {return}

   set contents "#  format is:  standard name (ie s9418#2.adc12)            alias  (ie strip1.E)\n"

   foreach item [array names Xlate] {
       append contents [format "%24s %24s\n" $item $Xlate($item)]
   }

    set contents [split [Edit_Xlate $contents] \n]

    if {[llength $contents] == 0} then {return}

#    data has been modified  - save to file

    set file [file join $env(EXPERIMENTBASE) Histconfigs [set SpectrumServer]_names]
    set z [catch {open $file w} f]
    if {$z != 0} then {midas-warning "Unable to write file $file\n$f"; return}

    foreach item $contents {
       if {[llength $item] == 2} then {
           puts $f "$item"
       }
    }
    close $f
    set-footer "$file updated"

#  update the arrays

    Make_Xlate $SpectrumServer
}

proc click-camac {action} {
  global CAMACEnable CAMACserver CAMACcontroller EGallow

  if {$CAMACEnable == 0} then {return}

   starttask camaccontrol

    switch $action {
      0    {set p DAQ-halt}
      1    {set p DAQ-go}
      2    {set p DAQ-reset}
    }

   set-busy

   do_inhibit_camac
 
   set-footer "sending $p to CAMAC control task"
   set z [catch {send camaccontrol $p} m]

   if {$action == 1} then {do_uninhibit_camac}

   clear-busy
   if {$m == ""} then {clear-footer} else {set-footer $m}
   redisplay-camac
}

proc  do_inhibit_camac {} {
  global CAMACserver CAMACcontroller EGallow

 insert-log "Setting CAMAC inhibit"

#    inhibit CAMAC
   set EGallow 0x10004
   if {$CAMACcontroller == "SCC"} then {
       set camacstate [EG "register :pattern '/$CAMACserver/SCC#*.set' :value '0x0004'"]
   }
   if {$CAMACcontroller == "RS232CC"} then {
       set camacstate [EG "register :pattern '/$CAMACserver/RS232CC#*.status' :value '0x000420'"]
   }
   if {$CAMACcontroller == "CC"} then {
       set camacstate [EG "register :pattern '/$CAMACserver/CC#*.SetI' :value '0'"]
   }
   set EGallow 0xffffffff
}

proc  do_uninhibit_camac {} {
  global CAMACserver CAMACcontroller EGallow

 insert-log "Clearing CAMAC inhibit"

#    uninhibit CAMAC
   set EGallow 0x10004
   if {$CAMACcontroller == "SCC"} then {
       set camacstate [EG "register :pattern '/$CAMACserver/SCC#*.clear' :value '0x0004'"]
   }
   if {$CAMACcontroller == "RS232CC"} then {
       set camacstate [EG "register :pattern '/$CAMACserver/RS232CC#*.status' :value '0x000400'"]
   }
   if {$CAMACcontroller == "CC"} then {
       set camacstate [EG "register :pattern '/$CAMACserver/CC#*.UnSetI' :value '0'"]
   }
   set EGallow 0xffffffff
}

proc redisplay-camac {} {
   global CAMACEnable CAMACPresent CAMACserver CAMACcontroller EGallow

  if {$CAMACPresent == 0} then {return}
  if {$CAMACEnable == 0} then {:modify CAMAC :value -1; return}

   set EGallow 0x10004
   if {$CAMACcontroller == "SCC"} then {
       set camacstate [EG "register :name '/$CAMACserver/SCC#1.status' ?value"]
   }
   if {$CAMACcontroller == "RS232CC"} then {
       set camacstate [EG "register :name '/$CAMACserver/RS232CC#1.status' ?value"]
   }
   if {$CAMACcontroller == "CC"} then {
       set camacstate [EG "register :name '/$CAMACserver/CC#1.TestI' ?value"]
   }
   set EGallow 0xffffffff

   if {$camacstate == "0x10004"} then {:modify CAMAC :value -1; return}

   if {$CAMACcontroller != "CC"} then {
       if {[second $camacstate] != "%11"} then {:modify CAMAC :value -1; return}
   } else {
       if {$camacstate == "%00"} then {:modify CAMAC :value -1; return}
   }

   if {$CAMACcontroller == "SCC"} then {
       set stat  [expr [first $camacstate] >> 6 & 1]
   }
   if {$CAMACcontroller == "RS232CC"} then {
       set stat  [expr [first $camacstate] >> 4 & 1]
   }
   if {$CAMACcontroller == "CC"} then {
       if {$camacstate == "%11"} then {set stat 1} else {set stat 0}
   }
   if {$stat != 0} then {:modify CAMAC :value 0} else {:modify CAMAC :value 1}
}

proc click-vme {action args} {
    global VMEPresent VMEEnable

  if {$VMEPresent == 0} then {return}
  if {$VMEEnable == 0} then {:modify VME :value -1; return}

   starttask vmecontrol

    switch $action {
      0    {set p DAQ-halt}
      1    {set p DAQ-go}
      2    {set p DAQ-reset}
      3    {set p DAQ-setup}
    }

   set-footer "sending $p to VME control task"
   set-busy
   if {[llength $args] == 0} then {
       set z [catch {send vmecontrol $p} m]
   } else {
       set z [catch {send vmecontrol $p [first $args]} m]
   }
   clear-busy
   if {$m == ""} then {clear-footer} else {set-footer $m}
   redisplay-vme
   update_button_states
}
proc redisplay-vme {} {:modify VME :value -1}


proc click-vxi {action args} {
    global VXIPresent VXIEnable

  if {$VXIPresent == 0} then {return}
  if {$VXIEnable == 0} then {:modify VXI :value -1; return}

   starttask vxicontrol

    switch $action {
      0    {set p DAQ-halt}
      1    {set p DAQ-go}
      2    {set p DAQ-flush}
      3    {set p DAQ-reset}
      4    {set p DAQ-setup}
    }

   set-footer "sending $p to VXI control task"
   set-busy
   if {[llength $args] == 0} then {
       set z [catch {send vxicontrol $p} m]
   } else {
       set z [catch {send vxicontrol $p [first $args]} m]
   }
   clear-busy
   if {$m == ""} then {clear-footer} else {set-footer $m}
   redisplay-vxi
   update_button_states
}

proc redisplay-vxi {} {
   global vxistate
   global VXIEnable

  if {$VXIEnable == 0} then {return}

   set-busy
   starttask vxicontrol

   catch {set vxistate [send vxicontrol read-vxistate]}
   :modify VXI :value $vxistate

   clear-busy
}

proc click-rdout  {v} {
   global RDOUTEnable RDOUThdwre

   if {$RDOUTEnable == 0} then {return}

    set z [catch {
        if {$v==0} then {
#    Halt
              after cancel Check-DA

              if {$RDOUThdwre == "D2VB" || $RDOUThdwre == "F2VB"} {
                  execute-command 15 "Flush"
                  after 2000     ;#  allow time for data to be read
              }

              execute-command 1 "Halt"
        }
        if {$v==1} then {
#    Go
              if {[read-register NetVar.DACQ.Cspectramapped] != 1} then {map_spectra}

              execute-command 2 "Go"
              after 5000 Check-DA
        }
        if {$v==2} then {
#    Setup
              after cancel Check-DA
              Setup_Rdout
              execute-command 3 "Setup"
        }
        if {$v==3} then {
#    Reset 
              after cancel Check-DA
              execute-command 9 "Reset"
        }
        wait_for_completion
    } m ]
    redisplay-rdout
    clear-footer
}

proc Setup_Rdout {} {}

proc redisplay-rdout {} {
   global VERSION  RDOUTEnable readoutstate
   if {$RDOUTEnable == 0} then {:modify RDOUT :value -1; return}
   set readoutstate [expr [read-register NetVar.DACQ.Sstate]-1]
   :modify RDOUT :value $readoutstate

   if {$VERSION == "1394" || $VERSION == "8080" || $VERSION == "D2VB"} then {
       starttask stats
       set rate1 [inform stats read-Rate 2]
       :modify EVENTRATE :value $rate1
       set rate2 [inform stats read-Rate 12]
       :modify TRIGRATE :value [expr $rate1 + $rate2]
   }
   if {$VERSION == "MIDAS"} {
   
       set StatsBlock [read-register NetVar.DACQ.Stats1]
       set RatesBlock [read-register NetVar.DACQ.Rates1]

       :modify GOOD :value [lindex $StatsBlock 26]    ;#   stats item 13
       :modify GOODR :value [lindex $RatesBlock 26]
   
       :modify BAD :value  [lindex $StatsBlock 22]    ;#   stats item 11
       :modify BADR :value [lindex $RatesBlock 22]
   }
   if {$VERSION == "F2VB"} {
   
       set StatsBlock [read-register NetVar.DACQ.Stats1]
       set RatesBlock [read-register NetVar.DACQ.Rates1]

       :modify GOOD :value [lindex $StatsBlock 26]    ;#   stats item 4
       :modify GOODR :value [lindex $RatesBlock 26]
   
       :modify BAD :value  [lindex $StatsBlock 22]    ;#   stats item 34
       :modify BADR :value [lindex $RatesBlock 22]
   }
}

proc click-tsenable {v} {
   global TSEnable
   set TSEnable $v
   :modify TAPE   :value -1
   :modify STREAM :value ""
   :modify RATE   :value ""
   :modify PERCENT :value ""
   redisplay-tapes
}

proc redisplay-tsenable {} {
   global TSEnable
   :modify TSENABLE :value $TSEnable
}

proc click-txenable  {v} {
    global  RDOUTEnable txEnable TSPresent
    if {$RDOUTEnable == 0} then {set txEnable 0; return} else {set txEnable $v}
    if {$TSPresent == 0 || [read-register NetVar.TS_Server] == ""} then {
        set txEnable 0
    } else {
        if {$RDOUTEnable != 0} then {write-register NetVar.DACQ.Ctxenable $txEnable}
    }
    redisplay-txenable
}

proc click-ebtxenable  {v} {
    global  RDOUTEnable ebtxEnable EBPresent
    if {$RDOUTEnable == 0} then {set ebtxEnable 0; return} else {set ebtxEnable $v}
    if {$EBPresent == 0 || [read-register NetVar.EB_Server] == ""} then {
        set ebtxEnable 0
    } else {
        if {$RDOUTEnable != 0} then {write-register NetVar.DACQ.Cebtxenable $ebtxEnable}
    }
    redisplay-ebtxenable
}

proc redisplay-txenable {} {
   global  RDOUTEnable txEnable  TSPresent
   if {$TSPresent == 0} then {return}
   if {$RDOUTEnable == 0} then {:modify TXENABLE :value 0; return}
   set txEnable [read-register NetVar.DACQ.Ctxenable]
   :modify TXENABLE :value $txEnable
}

proc redisplay-ebtxenable {} {
   global  RDOUTEnable ebtxEnable EBPresent
   if {$EBPresent == 0} then {return}
   if {$RDOUTEnable == 0} then {:modify EBTXENABLE :value 0; return}
   set ebtxEnable [read-register NetVar.DACQ.Cebtxenable]
   :modify EBTXENABLE :value $ebtxEnable
}

proc click-histenable {v} {
    global RDOUTEnable histEnable
    if {$RDOUTEnable == 0} then {set  histEnable 0} else {set histEnable $v}
    if {$RDOUTEnable != 0} then {write-register NetVar.DACQ.Chistenable $histEnable}
    redisplay-histenable
}

proc redisplay-histenable {} {
   global  RDOUTEnable histEnable
   if {$RDOUTEnable == 0} then {:modify HISTENABLE :value 0; return}
   set histEnable [read-register NetVar.DACQ.Chistenable]
   :modify HISTENABLE :value $histEnable
}

proc click-camacenable {v} {
    global debug  CAMACEnable
    set CAMACEnable $v
    redisplay-xxxenable
}

proc click-vmeenable {v} {
    global debug  VMEEnable
    set VMEEnable $v
    redisplay-xxxenable
}

proc click-vxienable {v} {
    global debug  VXIEnable
    set VXIEnable $v
    redisplay-xxxenable
}

proc click-rdoutenable {v} {
    global debug  RDOUTEnable
    if {$v == 0} then {
        if {[midas-confirmation "This will disable the Data Acquisition program\nAre you sure you want to do this?"] == 0} then {
            redisplay-xxxenable
            return
        }
    }
    set RDOUTEnable $v
    if {$RDOUTEnable == 0} then {
         click-histenable 0
         click-txenable 0
         click-ebtxenable 0
    }
    redisplay-xxxenable
    redisplay-rdout
}

proc redisplay-xxxenable {} {
  global CAMACEnable VMEEnable VXIEnable CAMACPresent VMEPresent VXIPresent RDOUTEnable

 if {$CAMACPresent == 1} {
    :modify CAMACENABLE :value $CAMACEnable
    redisplay-camac
 }
 if {$VMEPresent == 1} {
    :modify VMEENABLE :value $VMEEnable
    redisplay-vme
 }
 if {$VXIPresent == 1} {
    :modify VXIENABLE :value $VXIEnable
    redisplay-vxi
 }
   :modify RDOUTENABLE :value $RDOUTEnable
}

proc click-trace {v} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   write-register NetVar.DACQ.Ctrace $v
}

proc click-zero {} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   execute-command 6 "Zeroing X2VB RAM"
}

proc click-format {} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}
   global TestBuffer
   global EGreport

   if {$TestBuffer == ""} then {set-footer "No test buffer defined"; return}

    set EGreport_SAVE $EGreport
    set EGreport -1

    execute-command 5 "" -1

   foreach word $TestBuffer {
       execute-command 5 "" "0 $word"
   }

   execute-command 5 "Formatting X2VB RAM" 1

    set EGreport $EGreport_SAVE
}

proc click-special {a} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   execute-command $a "" 0 2
}

set TestBufferLen 1
proc click-testmode {a} {
   global TestBufferLen

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   if {$a == 0} then {

#    start test mode

       write-register NetVar.DACQ.TestMode $TestBufferLen
       write-register NetVar.EXEC.Action 5
       write-register SigTask.EXEC.Usr2 0
   } else {

#    stop test mode

       write-register NetVar.DACQ.TestMode 0
    }
}


proc Null_Events {vl} {
    global RDOUTEnable 
    if {$RDOUTEnable != 0} then {write-register NetVar.DACQ.Cignorenullevents $vl}
}

proc RdOut_Enable {vl} {
    global RDOUTEnable 
    if {$RDOUTEnable != 0} then {write-register NetVar.DACQ.Crdoutenable $vl}
}

if {$RDOUThdwre == "D2VB"} {

proc click-histmode {w v} {
    global RDOUTEnable HistMode
    if {$RDOUTEnable == 0} then {
        set HistMode 0
    } else {
        set HistMode $v
        write-register NetVar.DACQ.Chistmode $v
    }
    redisplay-histmode
}

proc redisplay-histmode {} {
   global RDOUTEnable HistMode
   if {$RDOUTEnable != 0} then {set HistMode [read-register NetVar.DACQ.Chistmode]}
   :modify HISTMODE :value $HistMode
}

} else {

proc click-histmode {w v} {
    global RDOUTEnable HistMode
    if {$RDOUTEnable == 0} then {set  HistMode 0} else {set HistMode $v}
    redisplay-histmode
}

proc redisplay-histmode {} {
   global HistMode
   :modify HISTMODE :value $HistMode
}

}

proc checkinstallation  {} {
   global OS VERSION env

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return 0}

   set ID [read-register NetVar.Executive.ID]
   if {[llength $ID] != 3} then {set ID [read-register NetVar.EXEC.ID]}

   set OS [first $ID]

   set ID [read-register NetVar.EXEC.ID]

   set version  [second $ID]
   set release [third $ID]

   if {$version != $VERSION} then {
       set msg " WARNING!  Possible system installation or setup error! \n\
       Require Data Acquisition program $VERSION but discovered \n\
       OS $OS; Program $version; Release $release\n\
       Do you wish to continue?"
       if {[midas-confirmation $msg] == 0} then {return 1}
   }

   set env(RTOS) $OS
   return 0
}

proc click-ID {} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

    set ID [read-register NetVar.Executive.ID]
    if {[llength $ID] == 3} then {
        set PID [read-register NetVar.Executive.PID]
        insert-log  "Executive: Target OS = [first $ID];  Program = [second $ID];  Version = [third $ID]; PID = $PID"
    } else {
        insert-log "Executive: program status currently not known"
    }

    set ID [read-register NetVar.EXEC.ID]
    if {[llength $ID] == 3} then {
        set PID [read-register NetVar.EXEC.PID]
        insert-log  "EXEC: Target OS = [first $ID];  Program = [second $ID];  Version = [third $ID]; PID = $PID"
    } else {
        insert-log "EXEC: program status currently not known"
    }
}

proc Check-DA {} {
   global OS Alive
   global CheckDAPeriod

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

#    this check only works if GOING

   if {$OS == "VxWorks"} then {return}

   if {[:query_Mapped .]} then {

       set z [catch {read-register NetVar.DACQ.Sstate} state]
       if {$z != 0} then {
           if {$CheckDAPeriod > 0} then {after [expr $CheckDAPeriod*1000] Check-DA}
           return
       }
       if {$state != 2} then {return}

       set-footer "Checking Data Acqusition Program"

       set z [catch {read-register NetVar.DACQ.CAlive} Alive]
       if {$z != 0} then {
           if {$CheckDAPeriod > 0} then {after [expr $CheckDAPeriod*1000] Check-DA}
           return
       }

       set z [catch {write-register NetVar.DACQ.CAlive 0}]
       if {$z != 0} then {
           if {$CheckDAPeriod > 0} then {after [expr $CheckDAPeriod*1000] Check-DA}
           return
       }

       if {$Alive == 0} then {
             set-footer "Warning - No data being received or the DA Program has crashed"
       } else {
             set-footer "Data Acquisition running OK"
       }

      click-redisplay

   }

   if {$CheckDAPeriod > 0} then {after [expr $CheckDAPeriod*1000] Check-DA}
}

proc click-redisplay {} {
    global VERSION
   set-footer "Updating display"
   catch redisplay-camac
   catch redisplay-vme
   catch redisplay-vxi
   catch redisplay-rdout
   catch redisplay-histenable
   catch redisplay-txenable
   catch redisplay-tsenable
   catch redisplay-ebtxenable
   catch redisplay-histmode
   catch redisplay-xxxenable
   catch redisplay-tapes
   catch Custom_Redisplay
if {$VERSION == "RISING"} then {catch redisplay-mbs}
   update_button_states
   set-footer "Display Updated [date]"
}  

proc da_state {} {
  global VXIEnable VMEEnable TSEnable RDOUTEnable
  global vxistate vmestate tapestate readoutstate

#    if any one of the controlled subsystems is in the GO state then the
#    overall state is GO button

  set state 0

  if {$VXIEnable == 1 && $vxistate == 1}     then {set state 1}
  if {$VMEEnable == 1 && $vmestate == 1}     then {set state 1}
  if {$TSEnable == 1 && $tapestate == 1}     then {set state 1}
  if {$RDOUTEnable == 1 && $readoutstate == 1}     then {set state 1}

  return $state
}

proc update_button_states {} {
  global VXIEnable VMEEnable TSEnable RDOUTEnable
  global vxistate vmestate tapestate readoutstate

#    if any one of the controlled subsystems is in the GO state then the
#    overall GO button should be disabled

  if {$VXIEnable == 1 && $vxistate == 1}     then {disable_go; return}
  if {$VMEEnable == 1 && $vmestate == 1}     then {disable_go; return}
  if {$TSEnable == 1 && $tapestate == 2}     then {disable_go; return}
  if {$RDOUTEnable == 1 && $readoutstate == 1}     then {disable_go; return}

  :modify DA-GO :colour green :inactive F
}

proc disable_go {} {:modify DA-GO :colour white :inactive T}
  
proc click arg {
    global debug actionlist setuplist ScalerType 
    if {$debug} then {puts stderr "click with argument \{$arg\}"}
    set f [lindex $arg 0]
    set c [lindex $arg 1]
    set w [lindex $arg 2]
    set v [lindex $arg 3]
    set i [lindex $arg 4]

    if {$c==":quit"} then {return [click-quit]}
    switch $w  {
                DA-STOP  {click-da 0; click-redisplay}
                DA-GO    {click-da 1; click-redisplay}

                CAMAC {click-camac $v}
                CAMACENABLE {click-camacenable $v}
                VME   {click-vme $v}
                VMEENABLE {click-vmeenable $v}
                VXI   {click-vxi $v}
                VXIENABLE {click-vxienable $v}
                RDOUT   {click-rdout $v}
                RDOUTENABLE {click-rdoutenable $v}
                HISTENABLE {click-histenable $v}
                TXENABLE {click-txenable $v}
                EBTXENABLE {click-ebtxenable $v}
                TSENABLE {click-tsenable $v}
                TAPE  {click-tapes $v}

                FORMATOPTION {write-register NetVar.Format_Option [expr $v+1]; update-test-frame}
                TSXFER       {write-register NetVar.Xfer_Option [expr $v+1]; update-test-frame}
                EBXFER       {write-register NetVar.EBXfer_Option [expr $v+1]; update-test-frame}
                TDCMODE      {write-register NetVar.TDC.Mode $v; update-test-frame}
                TDCOPTION    {write-register NetVar.TDC.Option $v; update-test-frame}
                TDCREF       {write-register NetVar.TDC.Reference $v; update-test-frame}
                RDOPT        {write-register NetVar.ReadOutOption $v; update-test-frame}

                SETUPS  {
                    eval [second [lindex $setuplist $i]]
                }

                ACTIONS  {
                    set action [lindex $actionlist $i]
                    set r [midas-confirmation "You are about to execute the action \"[first $action]\"\nAre you sure?"]
                    if {$r == 1} then {eval [second $action]}
                }

                MONITOR {
                    switch $v {
                       Statistics {inform stats start}
                       Monitoring {inform rates start}
                    }
                }

                SPECTRA {
                    switch $v {
                        "Spectrum Browser"  {inform sb start}
                        "Spectrum Viewer"   {inform sd start}
                    }
                }

                SCALERS {
                    switch $v {
                        Show  {inform $ScalerType start}
                        Clear {inform $ScalerType click-clear-all}
                    }
                }

        REDISPLAY {click-redisplay}
        STATISTICS {inform stats start}

        default {
           if {[info proc click-[lowercase $w]]=="click-[lowercase $w]"} then {
              click-[lowercase $w] $v
           } else {puts stdout $arg}
        }
    }
}

set Retry 0
proc click-Retry {v} {global Retry; set Retry $v}

proc check_for_experiment {} {
    global env Retry

    set z [catch {set env(EXPERIMENTBASE)}]
    if {$z == 1 || ![file isdirectory $env(EXPERIMENTBASE)]} then {

        :frame [self frame-name] :label "[self frame-title]" \
           :icon-image "@$env(ICONHOME)/default" \
           :icon-name "[self icon-title]" :resize F

        :panel P :layout T :padx 10 :pady 10
        :layout H; :col-gap 10; :row-gap 10

        :message M  :bold T :justify center :label "\
You are not connected to a useable experiment\n\
It is essential that you are connected to an experiment before starting the Experiment Control\n\
Please correct this and then click on Continue."

        :next-row T

        :button CONTINUE :label Continue :w 12 :command "click-Retry 0"
        :button ABORT    :label Abort    :w 12 :command "click-Retry 1"

        :show T

        tkwait variable Retry

         destroy-frame

        if {$Retry == 0} then {return 1} else {return -1}
    } else {return 0}
}

proc start args {
   global started env CAMACEnable VMEEnable VXIEnable TitrisPresent TSPresent TSEnable histEnable histPresent
   global resource SpectrumServer SpectrumServerList

   for {set i 0} {$i < 100} {incr i} {
       set rc [check_for_experiment]
       if {$rc < 0}  return
       if {$rc == 0} break
   }

   Set_Options
   Custom_Start

   set SpectrumServerList {}
   set histpresent 0
   if {[catch {eg "(experiment ?resources)"} m]} then {
       midas-warning "no experiment connected!!!"
   } else {
       foreach item $m {
          if {[second [fourth $item]] == "spectrum" && [second [fifth $item]] == "hist"} {
              lappend SpectrumServerList [second [first $item]]
          }
       }
   }

   if {[llength $SpectrumServerList] > 0} {
       set SpectrumServer [first $SpectrumServerList]
       set env(SHistServer) $SpectrumServer
       set resource $SpectrumServer
       set histpresent 1
   }

   if {$started == 0} then {make-frame}
   set started 1

if {$CAMACEnable == 1} then {
   starttask camaccontrol
   starttask camacsaverestore
}

if {$VMEEnable == 1} then {
   starttask vmecontrol
   starttask vmesaverestore
   if {[info exists TitrisPresent]} {starttask titris}
}

if {$VXIEnable == 1} then {
   starttask vxicontrol
   starttask vxirestore
}

   open-frame

   set tapepresent 0
   if {[catch {eg "(experiment ?resources)"} m]} then {
       midas-warning "no experiment connected!!!"
   } else {
       foreach item $m {
          if {[second [fourth $item]] == "tape"} {set tapepresent 1}
       }
   }

   if {$tapepresent == 0 && $TSPresent == 1 && $TSEnable == 1} then {
        set TSEnable 0
        midas-warning "No Tape Server has been discovered in your experiment\n\
           Tape Server control has been disabled\n\
           You may reenable after adding a Tape Server to your experiment"
   }

   if {$histpresent == 0 && $histPresent == 1 && $histEnable == 1} then {
        set histEnable 0
        set histPresent 0
        midas-warning "No Histogram Server has been discovered in your experiment\n\
           Histogram Server control has been disabled\n\
           You may reenable after adding a Histogram Server to your experiment"
   }
 
    make-registers
    make-executiveregisters

   click-redisplay
}

proc click-quit args {close-frame}

proc finish args {destroy-frame}

proc make-frame {} {
  global env RDOUThdwre actionlist setuplist
  global VERSION CAMACPresent VMEPresent VXIPresent X2VBPresent
  global HistMode
  global CAMACEnable VMEEnable VXIEnable 
  global RDOUTEnable TSPresent EBPresent
  global UCL


  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/default" \
      :icon-name "[self icon-title]" :resize F

   :container P1 :layout T
    :layout H; :row-gap 10; :col-gap 10

   :panel P1A :layout L :padx 10 :pady 10
    :layout H; :row-gap 10; :col-gap 10

if {$CAMACPresent == 1} {
      :choice CAMAC :label Camac: :strings [list Stop Go] :valuex 14c :value -1
      :checkbox CAMACENABLE :label "" :value $CAMACEnable
      :next-row T
      lappend actionlist "\"CAMAC Reset\" \"click-camac 2\""
   if {$X2VBPresent == 1} {
      lappend actionlist "\"Zero X2VB RAM\" \"click-zero\""
      lappend actionlist "\"Format X2VB RAM\" \"click-format\""
      lappend actionlist "\"Force X2VB Read Out\" \"RdOut_Enable 1\""
      lappend actionlist "\"Normal X2VB Read Out\" \"RdOut_Enable 0\""
   }

}
if {$VMEPresent == 1} {
      set label "VME:"
      if {$VERSION == "PRISMA"} then {set label "CLARA (VME)"}
      :choice VME :label $label :strings [list Stop Go] :valuex 14c :value -1
      :checkbox VMEENABLE :label "" :value $VMEEnable
      :next-row T
      lappend actionlist "\"VME Reset\" \"click-vme 2\""
}
if {$VXIPresent == 1} {
      set label "VXI:"
      if {$VERSION == "PRISMA"} then {set label "CLARA (VXI)"}
      :choice VXI :label $label :strings [list Stop Go] :valuex 14c :value -1
      :checkbox VXIENABLE :label "" :value $VXIEnable
      :next-row T
      lappend actionlist "\"Pause VXI\" \"click-vxipause 1\""     
      lappend actionlist "\"Resume VXI\" \"click-vxipause 0\""
      lappend actionlist "\"VXI Reset\" \"click-vxi 3\""
      lappend actionlist "\"VXI Setup\" \"click-vxi 4\""
      lappend actionlist "\"Ignore Null Events\" \"Null_Events 1\""
      lappend actionlist "\"Keep Null Events\" \"Null_Events 0\""
   if {$X2VBPresent == 1} {
      lappend actionlist "\"Zero X2VB RAM\" \"click-zero\""
      lappend actionlist "\"Format X2VB RAM\" \"click-format\""
      lappend actionlist "\"Force X2VB Read Out\" \"RdOut_Enable 1\""
      lappend actionlist "\"Normal X2VB Read Out\" \"RdOut_Enable 0\""
   }
}

#if {$RDOUThdwre != "VME" && $RDOUThdwre != "1394"} then {
#      set label "[set RDOUThdwre]"
#      if {$VERSION == "PRISMA"} then {set label "Readout"}
#      :choice RDOUT :label $label :strings [list Stop Go] :valuex 14c :value -1
#      lappend actionlist "\"[set RDOUThdwre] Setup\" \"click-rdout 2\""
#      lappend actionlist "\"[set RDOUThdwre] Reset\" \"click-rdout 3\""
#} else {
      :choice RDOUT :label Readout: :strings [list Stop Go] :valuex 14c :value -1
      lappend actionlist "\"Readout Setup\" \"click-rdout 2\""
      lappend actionlist "\"Readout Reset\" \"click-rdout 3\""
#}

      :checkbox RDOUTENABLE :label "" :value $RDOUTEnable

      if {$VERSION == "GREAT"} then {
         :choice PAUSE :label "" :exclusive F :strings [list Pause]  :value 0
         lappend actionlist "\"[set RDOUThdwre] Pause\" \"click-special 17\""
      }

if {$UCL == 1} then {
      :row-gap 20; :next-row T
      :number RUNTIME :label "Run Time (s)" :w 6 :min 0 :max 500 :command do-runtime
}

   :panel P1B :layout L :padx 10 :pady 10
    :layout H; :row-gap 10; :col-gap 10

      :button  DA-STOP  :label  STOP  :w 8 :h 3 :colour red
      :hskip 30
      :button  DA-GO    :label  GO    :w 8 :h 3 :colour green
      :next-row T
      :button DA-SETUP  :label SETUP  :w 26 :h 2 :colour yellow :command "click-setup 0"

  :container end

   :panel P2 :layout T :padx 10 :pady 10
    :layout H; :row-gap 10; :col-gap 10

if {$VERSION == "PRISMA"} then {
      global PRISMAEnable
      :checkbox TXENABLE         :label "CLARA => Merge Enabled"  :value 0  :valuex 25c
      :next-row T
      :choice PRISMA :label "PRISMA" :strings [list Stop Go] :valuex 14c :value -1  :command click-prisma
      :checkbox PRISMAENABLE :label "" :value $PRISMAEnable  :command click-prismaenable
      :message PWARN :label "Status not checked" :bold T
      :button PRISMAUPDATE :label Update :command update-prisma
      :button PRISMARESET  :label Reset  :command reset-prisma
      :next-row T
      lappend actionlist "\"PRISMA Setup\" \"click-prisma 2\""
      lappend actionlist "\"PRISMA Reset\" \"click-prisma 3\""
}
      :col-gap 20

      :checkbox HISTENABLE :label "Histogramming Enabled"    :value 0  :valuex 20c
      if {$VERSION != "GREAT" && $VERSION != "F2VB"} then {
         if {$VERSION == "Megha"} {set HistChoices [list None E T E&T]}
         if {$VERSION != "Megha"} {set HistChoices [list None All]}
         if {$VXIPresent == 1} {set HistChoices [list Event Raw]}
         :choice HISTMODE :label Histogram :strings $HistChoices :command click-histmode :value $HistMode
      }
      if {$VERSION == "GREAT" || $VXIPresent == 1} then {
         :button HIST :label "Histogram Setup" :command "send shist start"
      }
      
      if {$VERSION == "Megha" || $VERSION == "Charissa" || $VERSION == "TUDA"} {
         :menubutton SCALERS :label "Scalers" :strings [list Show Clear]
      }

      :next-row T
      :col-gap 10

if {$VERSION == "1394" || $VERSION == "8080" || $VERSION == "D2VB"} then {
      :text TRIGRATE    :label "Master Trigger Rate (/sec)" :w 6 :deaf T :valuex 22c
      :text EVENTRATE   :label "Accepted Event Rate (/sec)" :w 6 :deaf T :valuex 23c
      :next-row T
}

if {$VERSION == "RISING"} then {
      :text TRIGRATE    :label "Master Trigger Rate (/sec)" :w 6 :deaf T :valuex 22c
      :text EVENTRATE   :label "Accepted Event Rate (/sec)" :w 6 :deaf T :valuex 23c
      :next-row T

       :text TSSERVER      :label "MBS Server"  :w 8 :command do_tsserver
       :text TSPORT        :label "Port"        :w 5  :command do_tsport
       :button TSDEFINE    :label "Setup Connection"  :command do_tsdefine
       :button TSUNDEFINE  :label "End Connection" :command do_tsundefine

      :next-row T
      :checkbox TXACTIVE :label "MBS Connected" :deaf T
      :checkbox TXENABLE :label "MBS Transfer Enabled" :value 0
      :text TXRATE :label "Data Rate (Kbytes/sec)" :w 6 :deaf T
} else {

if {$VERSION != "PRISMA" && $VERSION != "TIARA"} {
if {$TSPresent != 0} {
if {$VERSION == "EXOGAM"} {
      :checkbox TXENABLE   :label "Tape Server / Merge Transfer Enabled"  :value 0
} else {
      :checkbox TXENABLE   :label "TS Transfer Enabled"  :value 0  :valuex 20c
}
}
if {$EBPresent != 0} {
      :checkbox EBTXENABLE :label "EB Transfer Enabled"  :value 0  :valuex 20c
}
if {$TSPresent != 0 || $EBPresent != 0} then {:next-row T}
}

if {$VERSION == "TIARA"} {
    if {$TSPresent != 0} {
      :checkbox TXENABLE   :label "TS Transfer Enabled"  :value 0  :valuex 20c
    } else {
      :checkbox TXENABLE :label "Transfer to Merge Enabled"  :value 0
    }
    :next-row T
}

if {$TSPresent} then {
     :choice TAPE :label Tapes: :strings [list Stop Go] :valuex 14c
     :checkbox TSENABLE   :label "Tape Server Enabled"  :value 0

      :button TAPECONTROL :label "Tape Control" :command "inform tape start"
      :next-row T
      :text STREAM  :label "Tapes in Use" :w 30 :deaf T
      :text RUN     :label "Run Number" :w 8 :deaf T  :value "unknown" 
      :next-row T
      :text RATE    :label "Tape Rate (Kbytes/sec)" :w 6 :deaf T
      :text PERCENT :label "Tape Used (%)" :w 6 :deaf T
}

}
if {$VERSION == "EXOGAM"} {
       :row-gap 10
       :next-row T
      :message MSG10 :label "Singles Rates (/sec)" 
       :text SINGRATE1  :label "Singles1" :w 8 :valuex 8c :deaf T
       :text SINGRATE2  :label "" :w 8 :valuex 12c :deaf T
       :next-row T
      :message MSG4 :label "Trigger Scaler Rates (/sec)" 
       :next-row T
       :text RATE1  :label "FTR1" :w 8 :valuex 5c :deaf T
       :text RATE2  :label "FTR2" :w 8 :valuex 5c :deaf T
       :text RATE3  :label "FTR3" :w 8 :valuex 5c :deaf T
       :text RATE4  :label "FTR4" :w 8 :valuex 5c :deaf T
       :next-row T
       :text RATE5  :label "FT" :w 8 :valuex 5c :deaf T
       :text RATE6  :label "Val" :w 8 :valuex 5c :deaf T
       :text RATE7  :label "Test" :w 8 :valuex 5c :deaf T
       :text RATE8  :label "Test" :w 8 :valuex 5c :deaf T
       :next-row T
       :row-gap 0
      :message MSG7 :label "Trigger Requests not handled" 
      :message DTPC :label "(0%)" :bold T
       :next-row T; :hskip 25
      :gauge DEADTIME :label "" :min 0 :max 100 :gauge-width 400 :gauge-height 10 :inactive T 
      [:path DEADTIME].scale configure -troughcolor yellow -background blue -sliderlength 20
}

if {$VERSION == "TAS"} {
      :next-row T
      :button HM413 :label "Update HM413 Histograms" :command click-HM413ReadOut
}

if {$VERSION == "MIDAS" || $VERSION == "F2VB"} {
      :next-row T
      :text GOOD  :label "Good events" :deaf T :w 10
      :text GOODR :label "/sec" :deaf T :w 6
      :text BAD   :label "Bad events" :deaf T :w 10
      :text BADR  :label "/sec" :deaf T :w 6
}

   :panel P3 :layout B :padx 10 :pady 10 :after FOOTER
    :layout H; :row-gap 10; :col-gap 5
      :button REDISPLAY    :label Redisplay
if {$VERSION == "EXOGAM"} {
      :menubutton MONITOR      :label Monitoring  :strings [list Statistics Monitoring]
} else {
      :button     STATISTICS   :command "inform stats start"
}
      :menubutton SPECTRA      :label Spectra     :strings [list "Spectrum Browser"  "Spectrum Viewer"]
      set menu {}
      foreach item $setuplist {lappend menu [first $item]}
      :menubutton SETUPS :label "Setup Options"  :strings $menu
      set menu {}
      foreach item $actionlist {lappend menu [first $item]}
      :menubutton ACTIONS :label "Advanced"  :strings $menu

   :show T

}

proc make-test-frame {} {

global actionlist RDOUThdwre VERSION
global TSPresent EBPresent

  :frame [self frame-name].adv :label "System Configuration, Test and Debug Only" :show-footer T :resize F

    :panel ADVP1 :layout T :padx 10 :pady 10
      :layout H; :row-gap 5; :col-gap 5

        set i 0
        foreach item $actionlist {
            :button A$i :label "[first $item]" :command "[second $item]" :w 24
            incr i
            if {[expr ($i/4)*4] == $i} {:next-row T}
        }

        if {$VERSION == "GREAT"} then {
            set item "\"VME SYSRESET\" \"inform SHARC do-sysreset\""
            :button A$i :label "[first $item]" :command "[second $item]" :w 24
            incr i
            if {[expr ($i/4)*4] == $i} {:next-row T}
        }

     :next-row T

    :message M011 :label "Data Acquisition System Executive" :bold T
      :next-row T
    :message M012 :label "program status currently not known"

      :next-row T

    :message M021 :label "Data Acquisition Program" :bold T
      :next-row T
    :message M022 :label "program status currently not known"
      :next-row T
       :text DAPGM      :label "Data Acquisition Program" :w 16
       :text DADIR      :label "Data Acquisition Program Directory" :w 44
      :next-row T
       :button DATERM   :label "Terminate Data Acquisition Program"
       :button DALOAD   :label "Load Data Acquisition Program"
       :hskip 100
       :button DAKILL   :label "Kill Data Acquisition Program"

      :next-row T

if {$RDOUThdwre == "D2VB" || $RDOUThdwre == "F2VB"} then {

    :message M1 :label "Test-data generator task options" :bold T
     :next-row T
       :col-gap 30

       :slider DELAYTICKS   :label "Delay (msecs)"  :min 1 :max 5000  :command do_pgmoption
       :slider POLLTICKS    :label "Buffers/Tick"   :min 1 :max 32    :command do_pgmoption
} else {

    :message M1 :label "program options" :bold T
     :next-row T
       :col-gap 30
       :row-gap 10

       :slider POLLTICKS    :label "Polling Delay"   :min 1 :max 500000  :command do_pgmoption
}

     :next-row T

if {$RDOUThdwre == "D2VB"} then {

    :message M2 :label "Data Acquisition Program Options" :bold T

      :next-row T
      :text DEBUGMODE1 :w 4 :label "Debug Mode 1" :command do_pgmoption
      :text DEBUGMODE2 :w 4 :label "Debug Mode 2" :command do_pgmoption
      :checkbox TIMEFILTER :label "Time Filter" :command do_pgmoption
      :checkbox DUPLICATECHECK  :label "Duplicate Item Check"  :command do_pgmoption
      :next-row T
      :checkbox TITRIS   :label "Titris Present"   :command do_pgmoption
      :checkbox CENTRUM  :label "Centrum Present"  :command do_pgmoption
}

if {$VERSION == "MIDAS"|| $VERSION == "TIARA" || $VERSION == "F2VB"} then {

      :col-gap 10
  
      :choice-stack TDCMODE   :label "TDC Mode"       :strings [list default normal "common stop" "common start"]
      :hskip 20
      :choice-stack TDCOPTION :label "TDC Hit Option" :strings [list default first last all]
      :number TDCREF          :label "TDC Reference"  :min 0 :max 127 :w 5 :value 0
      :text RDOPT             :label "Read Out Option"  :w 8 
      :next-row 
}

if {$VERSION != "RISING"} then {

    :choice-stack FORMATOPTION  :label "Format Option" :strings [list GANIL GSI MIDAS RAW]

    if {$VERSION == "GREAT"} then {
        :checkbox PILEUPRATE :label "Include Pileup in Stat/Rate" :command do_pileuprate
    }

    :next-row T
    :message M3 :label "Data Destinations" :bold T

#    if {$TSPresent}  then  {
     :next-row T
       :col-gap 10
       :text TSSERVER      :label "Tape Server" :w 12 :valuex 12c :command do_tsserver
       :text TSPORT        :label "Port"        :w 8  :command do_tsport
       :button TSDEFINE    :label "Setup Connection"  :command do_tsdefine
       :button TSUNDEFINE  :label "End Connection" :command do_tsundefine
       :choice-stack TSXFER  :label "Transfer Option" :strings [list 1 2 MIDAS GSI GANIL XDAQ]
#    }

#    if {$EBPresent}  then  {
     :next-row T
       :col-gap 10
       :text EBSERVER      :label "Event Builder" :w 12 :valuex 12c :command do_ebserver
       :text EBPORT        :label "Port"          :w 8  :command do_ebport
       :button EBDEFINE    :label "Setup Connection"  :command do_ebdefine
       :button EBUNDEFINE  :label "Cancel Connection" :command do_ebundefine
       :choice-stack EBXFER  :label "Transfer Option" :strings [list 1 2 MIDAS GSI GANIL XDAQ]
#    }
}

    :next-row T
       :button UPDATE :command update-test-frame

  :show T

   make-registers
   make-executiveregisters

    update-test-frame
}

proc update-test-frame {} {
   global VERSION OS RDOUThdwre TSPresent EBPresent
   global DAProgram DADirectory LynxOSDirectory

   checkinstallation
   set DADirectory $LynxOSDirectory    ;#  default
   if {$OS == "Linux"} then {global LinuxDirectory; set DADirectory $LinuxDirectory}
   if {$OS == "WIN32"} then {global Win32Directory; set DADirectory $Win32Directory} 

    set ID [read-register NetVar.Executive.ID]
    if {[llength $ID] == 3} then {
        set PID [read-register NetVar.Executive.PID]
        :modify M012 :label "Target OS = [first $ID];  Program = [second $ID];  Version = [third $ID]; PID = $PID"
    } else {
        :modify M012 :label "program status currently not known"
    }

    set ID [read-register NetVar.EXEC.ID]
    if {[llength $ID] == 3} then {
        set PID [read-register NetVar.EXEC.PID]
        :modify M022 :label "Target OS = [first $ID];  Program = [second $ID];  Version = [third $ID]; PID = $PID"
    } else {
        :modify M022 :label "program status currently not known"
    }

    :modify DAPGM :value $DAProgram
    :modify DADIR :value $DADirectory

    if {$RDOUThdwre == "D2VB" || $RDOUThdwre == "F2VB"} then {

       :modify DELAYTICKS  :value [read-register NetVar.DACQ.DelayTicks]
       :modify POLLTICKS   :value [read-register NetVar.DACQ.PollTicks]
    } else {

       :modify POLLTICKS   :value [read-register NetVar.DACQ.PollTicks]
    }

if {$RDOUThdwre == "D2VB"} then {
      :next-row T
      :modify DEBUGMODE1  :value [read-register NetVar.DACQ.DebugMode1]
      :modify DEBUGMODE2  :value [read-register NetVar.DACQ.DebugMode2]
      :modify TIMEFILTER  :value [read-register NetVar.TimeFilter]
      :modify DUPLICATECHECK  :value [read-register DuplicateCheck]
      :modify TITRIS      :value [read-register TitrisPresent]
      :modify CENTRUM     :value [read-register CentrumPresent]
}

if {$VERSION == "MIDAS" || $VERSION == "TIARA" || $VERSION == "F2VB"} then {
      :modify TDCMODE   :value [read-register NetVar.TDC.Mode]
      :modify TDCOPTION :value [read-register NetVar.TDC.Option]
      :modify TDCREF    :value [read-register NetVar.TDC.Reference]
      :modify RDOPT     :value [read-register NetVar.ReadOutOption]
}

if {$VERSION != "RISING"} then {

    :modify FORMATOPTION :value [expr [read-register NetVar.Format_Option]-1]

#    if {$TSPresent}  then  {
       :modify TSSERVER    :value [read-register NetVar.TS_Server]
       :modify TSPORT      :value [read-register NetVar.TS_Port]
       :modify TSXFER      :value [expr [read-register NetVar.Xfer_Option]-1]
#    }

#    if {$EBPresent}  then  {
       :modify EBSERVER    :value [read-register NetVar.EB_Server]
       :modify EBPORT      :value [read-register NetVar.EB_Port]
       :modify EBXFER      :value [expr [read-register NetVar.EBXfer_Option]-1]
#    }
}

     clear-footer [self frame-name].adv
}

proc click-dapgm {vl} {global DAProgram; set DAProgram $vl}
proc click-dadir {vl} {global DADirectory; set DADirectory $vl}

proc click-dakill {args} {

    set PID [read-register NetVar.EXEC.PID]
    executive-command "Killing PID $PID" "kill $PID"

    set-footer [self frame-name].adv "program with PID $PID killed"
}

proc click-daterm {args} {

    set PID [read-register NetVar.EXEC.PID]
    if {$PID == 0} then {
        set-footer [self frame-name].adv "no program loaded"
    } else {
        execute-command  22 "Terminating program" 0 2
        set-footer [self frame-name].adv "program with PID $PID terminated"
    }
}

proc click-daload {args} {
    global DAProgram  DADirectory

    set PATH [file join $DADirectory $DAProgram]
    executive-command "Loading Data Program" "nice $PATH"

    set-footer [self frame-name].adv "program $PATH loaded"
}

proc do_pgmoption {w v} {
    global RDOUTEnable
    if {$RDOUTEnable == 0} then {return}
    switch $w {
      DELAYTICKS  {write-register NetVar.DACQ.DelayTicks $v}
      POLLTICKS   {write-register NetVar.DACQ.PollTicks $v}
      DEBUGMODE1  {write-register NetVar.DACQ.DebugMode1 $v}
      DEBUGMODE2  {write-register NetVar.DACQ.DebugMode2 $v}
      TIMEFILTER  {write-register NetVar.TimeFilter $v}
      DUPLICATECHECK  {write-register DuplicateCheck $v}
      TITRIS      {write-register  TitrisPresent $v}
      CENTRUM     {write-register  CentrumPresent $v}
    }
}

proc do_tsserver {w s}  {write-register NetVar.TS_Server $s}
proc do_tsport   {w v}  {write-register NetVar.TS_Port $v}
proc do_tsdefine {}     {click-special 3}
proc do_tsundefine {}   {click-special 1}

proc do_ebserver {w s}  {write-register NetVar.EB_Server $s}
proc do_ebport   {w v}  {write-register NetVar.EB_Port $v}
proc do_ebdefine {}     {click-special 6}
proc do_ebundefine {}   {click-special 2}

proc do_clearstats {} {execute-command 7 "Clear Statistics"}

if {$VERSION == "GREAT"} then {
proc do_pileuprate {w v}  {write-register NetVar.DACQ.CPileupRate $v}
proc Poll_Ticks {v}  {do_pgmoption POLLTICKS $v}
}

#    The Options are experiment specific and normally used by SYS
#    However the same code as for the session preferences is used which allows for wider use in the future.
#    In this event these procedures may be moved to sys.common.tcl

proc get_Option_file {} {
    global env

#    look for the Option file 
    set pd $env(EXPERIMENTBASE)
    if {![file exists $pd]} then {
         insert-log "$pd does not exist - Join an experiment!"
         return {}
    }
    if {![file isdirectory $pd]} then {
         insert-log "$pwd is not useable - it is not a directory"
         return {}
    }
    set pf [file join $pd MidasOptions]
    set z [catch {set f [open $pf r]} m]
    if {$z != 0} then {
        set z [catch {set f [open $pf w]} m]
        if {$z != 0} then {
            insert-log "Unable to access $pf - $m"
            return 1
        }
        close $f
        return {}
    }

#    and read it
    set lines [split [read $f] "\n"]
    close $f

    return $lines
}

proc put_Option_file {lines} {
   global env

#    look for the Option file 
    set pd $env(EXPERIMENTBASE)
    if {![file exists $pd]} then {
         insert-log "$pd does not exist - Join an experiment!"
         return {}
    }
    if {![file isdirectory $pd]} then {
         insert-log "$pwd is not useable - it is not a directory"
         return {}
    }
    set pf [file join $pd MidasOptions]
    set z [catch {set f [open $pf w]} m]
    if {$z != 0} then {
        insert-log "Unable to access $pf - $m"
        return 1
    }

    foreach item $lines {
      if {$item != ""} {puts $f $item}
    }

    close $f
    return 0
}

#    save all Options for the current task
proc update_Options {} {
   global env Options

   set lines [get_Option_file]
   set key [Get_My_Name]
   set range [find-keyword $lines $key]
   if {[llength $range] > 0} then {
       set lines [lreplace $lines [first $range] [expr [second $range] + 1]]
   }

   lappend lines "## $key"
   foreach item [array names Options] {
       lappend lines "$item $Options($item)"
   }
   lappend lines "##"

   set z [put_Option_file $lines]
   return $z
}

#    load all Options for the current task
proc load_Options {} {
   global env Options

   set lines [get_Option_file]
   set key [Get_My_Name]
   set range [find-keyword $lines $key]

   if {[llength $range] > 1} then {
       set stuff [lrange $lines [expr [first $range]+1] [second $range]]
       foreach item $stuff {
           set Options([head $item]) [tail $item]
       }
   }
}

#    return task Options
proc get_Options {task} {
   global env

   set lines [get_Option_file]
   set key $task
   set range [find-keyword $lines $key]
   
   set Options {}

   if {[llength $range] > 1} then {
       set stuff [lrange $lines [expr [first $range]+1] [second $range]]
       foreach item $stuff {
           lappend Options [list [first $item] [second $item]]
       }
   } else {
       lappend Options [list Options.filename  "[file join $env(HOME) MidasOptions Options]"]
   }
   return $Options
}

